/********************************************************************
* File:			defines.h
* Autor:		Granzer Wolfgang | 0026013 | E-881 | woif@woif.org
*				Praus Fritz      | 0025854 | E-881 | fritz@praus.at
* Descripton:	headerfile for global definitions
*********************************************************************/

/******************************
 * NOTE: only makrodefinitions are allowed
 *******************************/

#ifndef __defines__
#define __defines__

#include <windows.h>
#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

//#include "GL/glew.h"

#include "GL/glut.h"
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glaux.h>
#include "GL/glext.h"


//enable synch. with mutexobject 
#define MUTEX

#define MY_PI       3.14159265358979323846
#define MAX_JDI_STRING_LENGTH	50

// return codes
#define JDI_SUCCESS			0
#define JDI_FAILED			-1
#define JDI_NOT_IMPLEMENTED	-2

// max. textures in one 3ds file
#define MAX_TEXTURES	100

#define VISIBLE	0
#define INVISIBLE 1
#define UNINIT	3

#define INFINITY	5000

#define GLOBAL_SCALE_FACTOR	1.0f

// movements speeds

#define VIEW_SPEED		0.0000001f


// shotduration (in sec)
#define RAIL_DURATION	2.0f
#define MINIGUN_DURATION 0.15f

// weapon damages
#define RAIL_DAMAGE		90
#define MG_DAMAGE		5

#define MAX_WEAPON	10

#define NUMBER_CONFIGS 25

// TEMP!!!!!!!
#define MODELPATH					"./models/"

// multiplayer defines

// enables debug messages for network
// disable this, if you don't want to 
// receive popups upon failures
//#define NETWORK_DEBUG_MESSAGES_ENABLE

// sleep intervall for sending messages in ms
#define NETWORK_SEND_INTERVALL	20

// new object msgs -> MSB 1 = new object
// also used for "object.type"
// 1xxxxxxx
#define DUKE_RED				0x80
#define DUKE_GREEN				0x81
#define BULLET_MG				0x82
#define BULLET_RAIL				0x83
#define MSG_NEW_ENVIRONMENT		0x84
#define ITEM_POWER25			0x85
#define ITEM_POWER15			0x86
#define ITEM_AMMO_MG			0x87
#define ITEM_AMMO_RAIL			0x88
#define ITEM_AMOR_50			0x89
#define ITEM_AMOR_100			0x8A
#define TERRAIN					0x8B
// to be continued...

//update msgs
// 00xxxxxx
#define MSG_UPDATE				0x0

// undef msgs
// 01xxxxxx
#define MSG_SERVERFULL			0x40
#define MSG_REMOVE				0x41
#define MSG_PLAYERNAME			0x42
#define MSG_FRAG				0x43
#define MSG_HIT					0x44
#define MSG_CLIENTID			0x45
#define MSG_LEVELID				0x46
#define MSG_ITEMFLAG			0x47
#define MSG_INITCLIENT			0x48
#define MSG_FRAGCOUNT			0x49
#define MSG_RESPAWN				0x4A
#define MSG_WEAPONINFO			0x4B


// controll msgs
#define MSG_DISCONNECT			0xFF



#endif
